#include <stdio.h>
#include <stdlib.h>
#include "Mesh.h"

Mesh::Mesh()
{
}

Mesh::~Mesh()
{
	////FIXME: M finne hvordan jeg skal f n inn hit...
	//int n = 4;
	//
	////deleting cubeCoords
	//for(int i=0; i<=n; i++) {
	//	for(int j=0; j<=n; j++) {
	//		delete[] cubeCoords[i][j];
	//	}
	//	delete[] cubeCoords[i];
	//}
	//delete[] cubeCoords;

 //   //deleting cubeGrid
	//for(int i=0; i<n; i++) {
	//	for(int j=0; j<n; j++) {
	//		delete[] cubeGrid[i][j];
	//	}
	//	delete[] cubeGrid[i];
	//}
	//delete[] cubeGrid;
}

void Mesh::DrawCubes(Cube* root) //recursive DFS
{
	if (!root->isLeaf){
		subCube* mCC = root->myChildren; //myCastedChildren
		for (int k=0; k<2; k++){
			for (int j=0; j<2; j++){
				for (int i=0; i<2; i++){
					DrawCubes( mCC->cubes[i][j][k] );
				}
			}
		}
	}
	else {
        DrawCube(root);
	}
}//DrawCubes()

void Mesh::DrawCube(Cube* leaf)
{	
	//diffuse material property for the organ
	GLfloat mat_diffuse[] = {leaf->material.r, leaf->material.g, leaf->material.b, 1.0};
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);

	hduVector3Df vert1;
	hduVector3Df vert2;
	hduVector3Df vert3;
	hduVector3Df edge1;
	hduVector3Df edge2;
	hduVector3Df surfNorm;

	//left face (Draw the faces CCW)
	vert1[0] = leaf->cv->v[0][0][0]->pos.x; vert1[1] = leaf->cv->v[0][0][0]->pos.y; vert1[2] = leaf->cv->v[0][0][0]->pos.z;
	vert2[0] = leaf->cv->v[0][2][0]->pos.x; vert2[1] = leaf->cv->v[0][2][0]->pos.y; vert2[2] = leaf->cv->v[0][2][0]->pos.z;
	vert3[0] = leaf->cv->v[0][0][2]->pos.x; vert3[1] = leaf->cv->v[0][0][2]->pos.y; vert3[2] = leaf->cv->v[0][0][2]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge2.crossProduct(edge1);
	glNormal3fv(surfNorm); //glNormal3f(-1,0,0);
	glVertex3f(leaf->cv->v[0][0][0]->pos.x, leaf->cv->v[0][0][0]->pos.y, leaf->cv->v[0][0][0]->pos.z);
	glVertex3f(leaf->cv->v[0][0][2]->pos.x, leaf->cv->v[0][0][2]->pos.y, leaf->cv->v[0][0][2]->pos.z);
	glVertex3f(leaf->cv->v[0][2][2]->pos.x, leaf->cv->v[0][2][2]->pos.y, leaf->cv->v[0][2][2]->pos.z);
	glVertex3f(leaf->cv->v[0][2][0]->pos.x, leaf->cv->v[0][2][0]->pos.y, leaf->cv->v[0][2][0]->pos.z);

	//right face
	vert1[0] = leaf->cv->v[2][0][0]->pos.x; vert1[1] = leaf->cv->v[2][0][0]->pos.y; vert1[2] = leaf->cv->v[2][0][0]->pos.z;
	vert2[0] = leaf->cv->v[2][2][0]->pos.x; vert2[1] = leaf->cv->v[2][2][0]->pos.y; vert2[2] = leaf->cv->v[2][2][0]->pos.z;
	vert3[0] = leaf->cv->v[2][0][2]->pos.x; vert3[1] = leaf->cv->v[2][0][2]->pos.y; vert3[2] = leaf->cv->v[2][0][2]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge1.crossProduct(edge2);
	glNormal3fv(surfNorm); //glNormal3f(1,0,0);
	glVertex3f(leaf->cv->v[2][0][0]->pos.x, leaf->cv->v[2][0][0]->pos.y, leaf->cv->v[2][0][0]->pos.z);
	glVertex3f(leaf->cv->v[2][2][0]->pos.x, leaf->cv->v[2][2][0]->pos.y, leaf->cv->v[2][2][0]->pos.z);
	glVertex3f(leaf->cv->v[2][2][2]->pos.x, leaf->cv->v[2][2][2]->pos.y, leaf->cv->v[2][2][2]->pos.z);
	glVertex3f(leaf->cv->v[2][0][2]->pos.x, leaf->cv->v[2][0][2]->pos.y, leaf->cv->v[2][0][2]->pos.z);
	
	//bottom face
	vert1[0] = leaf->cv->v[0][0][0]->pos.x; vert1[1] = leaf->cv->v[0][0][0]->pos.y; vert1[2] = leaf->cv->v[0][0][0]->pos.z;
	vert2[0] = leaf->cv->v[2][0][0]->pos.x; vert2[1] = leaf->cv->v[2][0][0]->pos.y; vert2[2] = leaf->cv->v[2][0][0]->pos.z;
	vert3[0] = leaf->cv->v[2][0][2]->pos.x; vert3[1] = leaf->cv->v[2][0][2]->pos.y; vert3[2] = leaf->cv->v[2][0][2]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge1.crossProduct(edge2);
	glNormal3fv(surfNorm); //glNormal3f(0,-1,0);
	glVertex3f(leaf->cv->v[0][0][0]->pos.x, leaf->cv->v[0][0][0]->pos.y, leaf->cv->v[0][0][0]->pos.z);
	glVertex3f(leaf->cv->v[2][0][0]->pos.x, leaf->cv->v[2][0][0]->pos.y, leaf->cv->v[2][0][0]->pos.z);
	glVertex3f(leaf->cv->v[2][0][2]->pos.x, leaf->cv->v[2][0][2]->pos.y, leaf->cv->v[2][0][2]->pos.z);
	glVertex3f(leaf->cv->v[0][0][2]->pos.x, leaf->cv->v[0][0][2]->pos.y, leaf->cv->v[0][0][2]->pos.z);

	//top face
	vert1[0] = leaf->cv->v[0][2][0]->pos.x; vert1[1] = leaf->cv->v[0][2][0]->pos.y; vert1[2] = leaf->cv->v[0][2][0]->pos.z;
	vert2[0] = leaf->cv->v[2][2][0]->pos.x; vert2[1] = leaf->cv->v[2][2][0]->pos.y; vert2[2] = leaf->cv->v[2][2][0]->pos.z;
	vert3[0] = leaf->cv->v[2][2][2]->pos.x; vert3[1] = leaf->cv->v[2][2][2]->pos.y; vert3[2] = leaf->cv->v[2][2][2]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge2.crossProduct(edge1);
	glNormal3fv(surfNorm); //glNormal3f(0,1,0);
	glVertex3f(leaf->cv->v[0][2][0]->pos.x, leaf->cv->v[0][2][0]->pos.y, leaf->cv->v[0][2][0]->pos.z);
	glVertex3f(leaf->cv->v[0][2][2]->pos.x, leaf->cv->v[0][2][2]->pos.y, leaf->cv->v[0][2][2]->pos.z);
	glVertex3f(leaf->cv->v[2][2][2]->pos.x, leaf->cv->v[2][2][2]->pos.y, leaf->cv->v[2][2][2]->pos.z);
	glVertex3f(leaf->cv->v[2][2][0]->pos.x, leaf->cv->v[2][2][0]->pos.y, leaf->cv->v[2][2][0]->pos.z);

	//back face
	vert1[0] = leaf->cv->v[0][0][0]->pos.x; vert1[1] = leaf->cv->v[0][0][0]->pos.y; vert1[2] = leaf->cv->v[0][0][0]->pos.z;
	vert2[0] = leaf->cv->v[0][2][0]->pos.x; vert2[1] = leaf->cv->v[0][2][0]->pos.y; vert2[2] = leaf->cv->v[0][2][0]->pos.z;
	vert3[0] = leaf->cv->v[2][0][0]->pos.x; vert3[1] = leaf->cv->v[2][0][0]->pos.y; vert3[2] = leaf->cv->v[2][0][0]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge1.crossProduct(edge2);
	glNormal3fv(surfNorm); //glNormal3f(0,0,-1);
	glVertex3f(leaf->cv->v[0][0][0]->pos.x, leaf->cv->v[0][0][0]->pos.y, leaf->cv->v[0][0][0]->pos.z);
	glVertex3f(leaf->cv->v[0][2][0]->pos.x, leaf->cv->v[0][2][0]->pos.y, leaf->cv->v[0][2][0]->pos.z);
	glVertex3f(leaf->cv->v[2][2][0]->pos.x, leaf->cv->v[2][2][0]->pos.y, leaf->cv->v[2][2][0]->pos.z);
	glVertex3f(leaf->cv->v[2][0][0]->pos.x, leaf->cv->v[2][0][0]->pos.y, leaf->cv->v[2][0][0]->pos.z);
	
	//front face
	vert1[0] = leaf->cv->v[0][0][2]->pos.x; vert1[1] = leaf->cv->v[0][0][2]->pos.y; vert1[2] = leaf->cv->v[0][0][2]->pos.z;
	vert2[0] = leaf->cv->v[0][2][2]->pos.x; vert2[1] = leaf->cv->v[0][2][2]->pos.y; vert2[2] = leaf->cv->v[0][2][2]->pos.z;
	vert3[0] = leaf->cv->v[2][0][2]->pos.x; vert3[1] = leaf->cv->v[2][0][2]->pos.y; vert3[2] = leaf->cv->v[2][0][2]->pos.z;
	edge1 = vert2 - vert1;
	edge2 = vert3 - vert2;
	surfNorm = edge2.crossProduct(edge1);
	//std::cout << edge1 << edge2 << "   " << surfNorm << "\n";
	glNormal3fv(surfNorm); //glNormal3f(0,0,1);

	/*mat_diffuse[0] = 0; mat_diffuse[1] = 0; mat_diffuse[2] = 1;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);*/
	glVertex3f(leaf->cv->v[0][0][2]->pos.x, leaf->cv->v[0][0][2]->pos.y, leaf->cv->v[0][0][2]->pos.z);
	/*mat_diffuse[0] = leaf->material.r;  mat_diffuse[1] = leaf->material.g;  mat_diffuse[2] = leaf->material.b;
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);*/
	glVertex3f(leaf->cv->v[2][0][2]->pos.x, leaf->cv->v[2][0][2]->pos.y, leaf->cv->v[2][0][2]->pos.z);
	glVertex3f(leaf->cv->v[2][2][2]->pos.x, leaf->cv->v[2][2][2]->pos.y, leaf->cv->v[2][2][2]->pos.z);
	glVertex3f(leaf->cv->v[0][2][2]->pos.x, leaf->cv->v[0][2][2]->pos.y, leaf->cv->v[0][2][2]->pos.z);

}//DrawCube

void Mesh::MakeVertList(Cube* root)
{
	if (!root->isLeaf){
		subCube* mCC = root->myChildren;
		for (int k=0; k<2; k++){
			for (int j=0; j<2; j++){
				for (int i=0; i<2; i++){
					MakeVertList( mCC->cubes[i][j][k] );
				}
			}
		}
	}
	else {
		//printf("makeVertList called with leaf...\n");
		for (int k=0; k<3; k+=2){
			for (int j=0; j<3; j+=2){
				for (int i=0; i<3; i+=2){
					verteksList.push_back(root->cv->v[i][j][k]);
					for (int l=0; l<(verteksList.size()-1); l++){
						/*If the vertex is found in the list before the last element, it's(the one thats just added) popped off again*/
						if ( verteksList[l] == root->cv->v[i][j][k] ){
							verteksList.pop_back();
							break;
						}
					}
				}
			}
		}
	}
}//MakeVertList

void Mesh::RemoveFromVerteksList(Verteks* v)
{
	int n = verteksList.size();
	cout << "RemoveFromVerteksList, n: " << n <<"\n";

	for (int i=0; i<n; i++) {
		if(verteksList[i] == v){
			verteksList.erase( verteksList.begin()+i ); //gets the (i+1)'th element. THAT IS verteksList[i]!!
		}
		break;
	}
	if (i >= n) printf("RemoveFromVerteksList: Verteks not found!!!");
}//Mesh::RemoveFromVerteksList

void Mesh::VAddNeighbors()
{
	if(verteksList.size()>0){
		for (int i=0; i<verteksList.size(); i++){
			verteksList[i]->vNeig.clear();
			verteksList[i]->addNeighb();
		}
	}
	else{
		printf("verteksList not made!!!");
	}
}//Mesh::VAddNeighbors

//n must be 2,4,8,16...
void Mesh::initGeometry(int dim)
{
	dimCubes = dim;
	int n = dimCubes;
	
	//Need n+1^3 vertices for n^3 cubes
	cubeCoords = new coord**[n+1];
	orgCubeC = new coord**[n+1];
	for(int a=0; a<=n; a++) {
		cubeCoords[a] = new coord*[n+1];
		orgCubeC[a] = new coord*[n+1];
		for(int c=0; c<=n; c++) {
			cubeCoords[a][c] = new coord[n+1];
			orgCubeC[a][c] = new coord[n+1];
		}
	}
	//n^3 cubes
	cubeGrid = new cube**[n];
	cubeColor = new rgb**[n];
	for(int d=0; d<n; d++) {
		cubeGrid[d] = new cube*[n];
		cubeColor[d] = new rgb*[n];
		for(int e=0; e<n; e++) {
			cubeGrid[d][e] = new cube[n];
			cubeColor[d][e] = new rgb[n];
		}
	}

	int i = 0;
	int j = 0;
	int k = 0;

	int bias = n/2;
	cube tmpCube;
	
	//left to right, bottom to top, back to front
	for (k=-n/2; k<=(n/2); k++){//z
		for (j=-n/2; j<=(n/2); j++){//y
			for (i=-n/2; i<=(n/2); i++){//x
				cubeCoords[i+bias][j+bias][k+bias].x = (float)i; //x-coordinate
				cubeCoords[i+bias][j+bias][k+bias].y = (float)j; //y-coordinate
				cubeCoords[i+bias][j+bias][k+bias].z = (float)k; //z-coordinate

				orgCubeC[i+bias][j+bias][k+bias].x = (float)i; //x-coordinate
				orgCubeC[i+bias][j+bias][k+bias].y = (float)j; //y-coordinate
				orgCubeC[i+bias][j+bias][k+bias].z = (float)k; //z-coordinate
			}
		}
	}

	i = 0;
	j = 0;
	k = 0;

	//left to right, bottom to top, back to front
	for (k=0; k<n; k++){//z
		for (j=0; j<n; j++){//y
			for (i=0; i<n; i++){//x

				tmpCube.left[0]=cubeCoords[i][j][k];    tmpCube.left[1]=cubeCoords[i][j+1][k];    tmpCube.left[2]=cubeCoords[i][j+1][k+1];    tmpCube.left[3]=cubeCoords[i][j][k+1];
				tmpCube.right[0]=cubeCoords[i+1][j][k]; tmpCube.right[1]=cubeCoords[i+1][j+1][k]; tmpCube.right[2]=cubeCoords[i+1][j+1][k+1]; tmpCube.right[3]=cubeCoords[i+1][j][k+1];
				tmpCube.bottom[0]=cubeCoords[i][j][k];  tmpCube.bottom[1]=cubeCoords[i+1][j][k];  tmpCube.bottom[2]=cubeCoords[i+1][j][k+1];  tmpCube.bottom[3]=cubeCoords[i][j][k+1];
				tmpCube.top[0]=cubeCoords[i][j+1][k];   tmpCube.top[1]=cubeCoords[i+1][j+1][k];   tmpCube.top[2]=cubeCoords[i+1][j+1][k+1];   tmpCube.top[3]=cubeCoords[i][j+1][k+1];
				tmpCube.front[0]=cubeCoords[i][j][k+1]; tmpCube.front[1]=cubeCoords[i][j+1][k+1]; tmpCube.front[2]=cubeCoords[i+1][j+1][k+1]; tmpCube.front[3]=cubeCoords[i+1][j][k+1];
				tmpCube.back[0]=cubeCoords[i][j][k];    tmpCube.back[1]=cubeCoords[i][j+1][k];    tmpCube.back[2]=cubeCoords[i+1][j+1][k];    tmpCube.back[3]=cubeCoords[i+1][j][k];

				cubeGrid[i][j][k] = tmpCube;

				cubeColor[i][j][k].r = 0.67;
				cubeColor[i][j][k].g = 0.26;
				cubeColor[i][j][k].b = 0.15;
			}
		}
	}

}//initGeometry()

//n must be 2,4,8,16...
void Mesh::GenerateMesh()
{
	int n = dimCubes;

	float r = 1.0;
	float g = 1.0;
	float b = 1.0;

	int i = 0;
	int j = 0;
	int k = 0;

	//diffuse material property for the organ
	GLfloat mat_diffuse[] = {0.67, 0.26, 0.15, 1.0};

	//printf("x,y,z = %i, %i, %i", x, y, z);

	// To awoid the
	glPushMatrix();
	
	glBegin(GL_QUADS);
	//glColor3f(1, 0, 0);

	hduVector3Df vert1;
	hduVector3Df vert2;
	hduVector3Df vert3;
	hduVector3Df edge1;
	hduVector3Df edge2;
	hduVector3Df surfNorm;

	//left to right, bottom to top, back to front
	for (k=0; k<n; k++){//z
		//r -= 1.0/((float)(n+1));
		for (j=0; j<n; j++){//y
			//g -= 1.0/((float)(n+1));
			for (i=0; i<n; i++){//x
				//b -= 1.0/((float)(n+1));
				
				//glColor3f(cubeColor[i][j][k].r, cubeColor[i][j][k].g, cubeColor[i][j][k].b);
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
				
				/* Left face: correct winding: 0-3-2-1*/
				//vert1[0]=cubeGrid[i][j][k].left[0].x; vert1[1]=cubeGrid[i][j][k].left[0].y; vert1[2]=cubeGrid[i][j][k].left[0].z;
				//vert2[0]=cubeGrid[i][j][k].left[1].x; vert2[1]=cubeGrid[i][j][k].left[1].y; vert2[2]=cubeGrid[i][j][k].left[1].z;
				//vert3[0]=cubeGrid[i][j][k].left[2].x; vert3[1]=cubeGrid[i][j][k].left[2].y; vert3[2]=cubeGrid[i][j][k].left[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge2.crossProduct(edge1);//winding 0-3-2-1 gives edge2.cP(edge1)
				//glNormal3fv(surfNorm); //glNormal3f(-1,0,0);
				glVertex3f(cubeGrid[i][j][k].left[0].x, cubeGrid[i][j][k].left[0].y, cubeGrid[i][j][k].left[0].z);
				glVertex3f(cubeGrid[i][j][k].left[3].x, cubeGrid[i][j][k].left[3].y, cubeGrid[i][j][k].left[3].z);
				glVertex3f(cubeGrid[i][j][k].left[2].x, cubeGrid[i][j][k].left[2].y, cubeGrid[i][j][k].left[2].z);
				glVertex3f(cubeGrid[i][j][k].left[1].x, cubeGrid[i][j][k].left[1].y, cubeGrid[i][j][k].left[1].z);

				//correct winding: 0-1-2-3
                //vert1[0]=cubeGrid[i][j][k].right[0].x; vert1[1]=cubeGrid[i][j][k].right[0].y; vert1[2]=cubeGrid[i][j][k].right[0].z;
				//vert2[0]=cubeGrid[i][j][k].right[1].x; vert2[1]=cubeGrid[i][j][k].right[1].y; vert2[2]=cubeGrid[i][j][k].right[1].z;
				//vert3[0]=cubeGrid[i][j][k].right[2].x; vert3[1]=cubeGrid[i][j][k].right[2].y; vert3[2]=cubeGrid[i][j][k].right[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge1.crossProduct(edge2);//winding 0-1-2-3 gives edge1.cP(edge2)
				//glNormal3fv(surfNorm); 
				//glNormal3f(1,0,0);
				glVertex3f(cubeGrid[i][j][k].right[0].x,  cubeGrid[i][j][k].right[0].y,  cubeGrid[i][j][k].right[0].z);
				glVertex3f(cubeGrid[i][j][k].right[1].x,  cubeGrid[i][j][k].right[1].y,  cubeGrid[i][j][k].right[1].z);
				glVertex3f(cubeGrid[i][j][k].right[2].x,  cubeGrid[i][j][k].right[2].y,  cubeGrid[i][j][k].right[2].z);
				glVertex3f(cubeGrid[i][j][k].right[3].x,  cubeGrid[i][j][k].right[3].y,  cubeGrid[i][j][k].right[3].z);

				//correct winding: 0-1-2-3
				//vert1[0]=cubeGrid[i][j][k].bottom[0].x; vert1[1]=cubeGrid[i][j][k].bottom[0].y; vert1[2]=cubeGrid[i][j][k].bottom[0].z;
				//vert2[0]=cubeGrid[i][j][k].bottom[1].x; vert2[1]=cubeGrid[i][j][k].bottom[1].y; vert2[2]=cubeGrid[i][j][k].bottom[1].z;
				//vert3[0]=cubeGrid[i][j][k].bottom[2].x; vert3[1]=cubeGrid[i][j][k].bottom[2].y; vert3[2]=cubeGrid[i][j][k].bottom[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge1.crossProduct(edge2); //winding 0-1-2-3 gives edge1.cP(edge2)
				//glNormal3fv(surfNorm); 
				//glNormal3f(0,-1,0);
				glVertex3f(cubeGrid[i][j][k].bottom[0].x, cubeGrid[i][j][k].bottom[0].y, cubeGrid[i][j][k].bottom[0].z);
				glVertex3f(cubeGrid[i][j][k].bottom[1].x, cubeGrid[i][j][k].bottom[1].y, cubeGrid[i][j][k].bottom[1].z);
				glVertex3f(cubeGrid[i][j][k].bottom[2].x, cubeGrid[i][j][k].bottom[2].y, cubeGrid[i][j][k].bottom[2].z);
				glVertex3f(cubeGrid[i][j][k].bottom[3].x, cubeGrid[i][j][k].bottom[3].y, cubeGrid[i][j][k].bottom[3].z);

				//correct winding: 0-3-2-1
				//vert1[0]=cubeGrid[i][j][k].top[0].x; vert1[1]=cubeGrid[i][j][k].top[0].y; vert1[2]=cubeGrid[i][j][k].top[0].z;
				//vert2[0]=cubeGrid[i][j][k].top[1].x; vert2[1]=cubeGrid[i][j][k].top[1].y; vert2[2]=cubeGrid[i][j][k].top[1].z;
				//vert3[0]=cubeGrid[i][j][k].top[2].x; vert3[1]=cubeGrid[i][j][k].top[2].y; vert3[2]=cubeGrid[i][j][k].top[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge2.crossProduct(edge1); //winding 0-3-2-1 gives edge2.cP(edge1)
				//glNormal3fv(surfNorm); //glNormal3f(0,1,0);
				glVertex3f(cubeGrid[i][j][k].top[0].x, cubeGrid[i][j][k].top[0].y, cubeGrid[i][j][k].top[0].z);
				glVertex3f(cubeGrid[i][j][k].top[3].x, cubeGrid[i][j][k].top[3].y, cubeGrid[i][j][k].top[3].z);
				glVertex3f(cubeGrid[i][j][k].top[2].x, cubeGrid[i][j][k].top[2].y, cubeGrid[i][j][k].top[2].z);
				glVertex3f(cubeGrid[i][j][k].top[1].x, cubeGrid[i][j][k].top[1].y, cubeGrid[i][j][k].top[1].z);

				//correct winding: 0-1-2-3
				//vert1[0]=cubeGrid[i][j][k].back[0].x; vert1[1]=cubeGrid[i][j][k].back[0].y; vert1[2]=cubeGrid[i][j][k].back[0].z;
				//vert2[0]=cubeGrid[i][j][k].back[1].x; vert2[1]=cubeGrid[i][j][k].back[1].y; vert2[2]=cubeGrid[i][j][k].back[1].z;
				//vert3[0]=cubeGrid[i][j][k].back[2].x; vert3[1]=cubeGrid[i][j][k].back[2].y; vert3[2]=cubeGrid[i][j][k].back[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge1.crossProduct(edge2); //winding 0-1-2-3 gives edge1.cP(edge2)
				//glNormal3fv(surfNorm);
				//glNormal3f(0,0,-1);
				glVertex3f(cubeGrid[i][j][k].back[0].x, cubeGrid[i][j][k].back[0].y, cubeGrid[i][j][k].back[0].z);
				glVertex3f(cubeGrid[i][j][k].back[1].x, cubeGrid[i][j][k].back[1].y, cubeGrid[i][j][k].back[1].z);
				glVertex3f(cubeGrid[i][j][k].back[2].x, cubeGrid[i][j][k].back[2].y, cubeGrid[i][j][k].back[2].z);
				glVertex3f(cubeGrid[i][j][k].back[3].x, cubeGrid[i][j][k].back[3].y, cubeGrid[i][j][k].back[3].z);

				//correct winding: 0-3-2-1
				//vert1[0]=cubeGrid[i][j][k].front[0].x; vert1[1]=cubeGrid[i][j][k].front[0].y; vert1[2]=cubeGrid[i][j][k].front[0].z;
				//vert2[0]=cubeGrid[i][j][k].front[1].x; vert2[1]=cubeGrid[i][j][k].front[1].y; vert2[2]=cubeGrid[i][j][k].front[1].z;
				//vert3[0]=cubeGrid[i][j][k].front[2].x; vert3[1]=cubeGrid[i][j][k].front[2].y; vert3[2]=cubeGrid[i][j][k].front[2].z;
				//edge1 = vert2 - vert1;
				//edge2 = vert3 - vert2;
				//surfNorm = edge2.crossProduct(edge1); //winding 0-3-2-1 gives edge2.cP(edge1)
				////std::cout << edge1 << edge2 << "   " << surfNorm << "\n";
				//glNormal3fv(surfNorm); //glNormal3f(0,0,1);
				glVertex3f(cubeGrid[i][j][k].front[0].x, cubeGrid[i][j][k].front[0].y, cubeGrid[i][j][k].front[0].z);
				glVertex3f(cubeGrid[i][j][k].front[3].x, cubeGrid[i][j][k].front[3].y, cubeGrid[i][j][k].front[3].z);
				glVertex3f(cubeGrid[i][j][k].front[2].x, cubeGrid[i][j][k].front[2].y, cubeGrid[i][j][k].front[2].z);
				glVertex3f(cubeGrid[i][j][k].front[1].x, cubeGrid[i][j][k].front[1].y, cubeGrid[i][j][k].front[1].z);
			}
		}
	}

	glEnd();

	glPopMatrix();
}//GenerateMesh

void Mesh::GetTouchedCube(hduVector3Dd proxyPos, int *hCI)
{
	int n = dimCubes;
	//int retur[3];//to fill with the hitCubeIndices

	int k = 0;
	int j = 0;
	int i = 0;
	
	int xItStart;
	int xItStop;
	int yItStart;
	int yItStop;
	int zItStart;
	int zItStop;

	int xHit;
	int yHit;
	int zHit;
	
	hduVector3Dd tmpVertice;

	//should be safe with 1, but...
	float minDist = 100;
	//[0]=x=i, [1]=y=j, [2]=z=k
	int minDistVert[3] = {-1,-1,-1};

	//Dividing search space in 8 (2^3)
	if (proxyPos[0]>0) {xItStart=dimCubes/2; xItStop=dimCubes;} else {xItStart=0; xItStop=dimCubes/2;}
	if (proxyPos[1]>0) {yItStart=dimCubes/2; yItStop=dimCubes;} else {yItStart=0; yItStop=dimCubes/2;}
	if (proxyPos[2]>0) {zItStart=dimCubes/2; zItStop=dimCubes;} else {zItStart=0; zItStop=dimCubes/2;}

	for ( k=zItStart; k<zItStop; k++){
		for ( j=yItStart; j<yItStop; j++){
			for ( i=xItStart; i<xItStop; i++){

				tmpVertice[0]=cubeCoords[i][j][k].x; tmpVertice[1]=cubeCoords[i][j][k].y; tmpVertice[2]=cubeCoords[i][j][k].z;
				if (proxyPos.distance(tmpVertice) < minDist){
					minDist = proxyPos.distance(tmpVertice);
					minDistVert[0]=i; minDistVert[1]=j; minDistVert[2]=k;
				}
			}
		}
	}

	if (proxyPos[0] > cubeCoords[minDistVert[0]][minDistVert[1]][minDistVert[2]].x) xHit=minDistVert[0];
	else xHit=minDistVert[0]-1;
	if (xHit<0) xHit=0;
	else if (xHit>n-1)xHit=n-1;

	if (proxyPos[1] > cubeCoords[minDistVert[0]][minDistVert[1]][minDistVert[2]].y) yHit=minDistVert[1];
	else yHit=minDistVert[1]-1;
	if (yHit<0) yHit=0;
	else if (yHit>n-1)yHit=n-1;

	if (proxyPos[2] > cubeCoords[minDistVert[0]][minDistVert[1]][minDistVert[2]].z) zHit=minDistVert[2];
	else zHit=minDistVert[2]-1;
	if (zHit<0) zHit=0;
	else if (zHit>n-1)zHit=n-1;

	//std::cout << "cube " << xHit << yHit << zHit << " Hit!\n";

	cubeColor[xHit][yHit][zHit].r = 0;
	cubeColor[xHit][yHit][zHit].g = 0;
	cubeColor[xHit][yHit][zHit].b = 1;

	*hCI=xHit; hCI++;
	*hCI=yHit; hCI++;
	*hCI=zHit;

}//GetTouchedCube

void Mesh::GetTouchedFace(hduVector3Dd proxyPos, int hitCube[], int *hitFace)
{
	//0=left, 1=right, 2=bottom, 3=top, 4=back, 5=front

	//getting the hit cube indices in the hitCube variable
	GetTouchedCube(proxyPos, hitCube);

	//The proxy will(should!!) always stay outside the object. Thats way this work
	if( proxyPos[0] < cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].left[0].x )
		*hitFace=0;
	else if (proxyPos[0] > cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].right[0].x)
		*hitFace=1;
	else if (proxyPos[1] < cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].bottom[0].y)
		*hitFace=2;
	else if (proxyPos[1] > cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].top[0].y)
		*hitFace=3;
	else if (proxyPos[2] < cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].back[0].z)
		*hitFace=4;
	else if (proxyPos[2] > cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].front[0].z)
		*hitFace=5;
	else {*hitFace = prevHitFace; std::cout << "ERROR!! " << " " << " ";}

	prevHitFace = *hitFace;
	std::cout << "prevHF satt til:  " << prevHitFace << " hit\n";

    //std::cout << "face " << *hitFace << " hit\n";

}//GetTouchedFace

void Mesh::UpdateGeometry()
{
	int n=dimCubes;
	cube tmpCube;

	//left to right, bottom to top, back to front
	for (int k=0; k<n; k++){//z
		for (int j=0; j<n; j++){//y
			for (int i=0; i<n; i++){//x

				tmpCube.left[0]=cubeCoords[i][j][k];    tmpCube.left[1]=cubeCoords[i][j+1][k];    tmpCube.left[2]=cubeCoords[i][j+1][k+1];    tmpCube.left[3]=cubeCoords[i][j][k+1];
				tmpCube.right[0]=cubeCoords[i+1][j][k]; tmpCube.right[1]=cubeCoords[i+1][j+1][k]; tmpCube.right[2]=cubeCoords[i+1][j+1][k+1]; tmpCube.right[3]=cubeCoords[i+1][j][k+1];
				tmpCube.bottom[0]=cubeCoords[i][j][k];  tmpCube.bottom[1]=cubeCoords[i+1][j][k];  tmpCube.bottom[2]=cubeCoords[i+1][j][k+1];  tmpCube.bottom[3]=cubeCoords[i][j][k+1];
				tmpCube.top[0]=cubeCoords[i][j+1][k];   tmpCube.top[1]=cubeCoords[i+1][j+1][k];   tmpCube.top[2]=cubeCoords[i+1][j+1][k+1];   tmpCube.top[3]=cubeCoords[i][j+1][k+1];
				tmpCube.front[0]=cubeCoords[i][j][k+1]; tmpCube.front[1]=cubeCoords[i][j+1][k+1]; tmpCube.front[2]=cubeCoords[i+1][j+1][k+1]; tmpCube.front[3]=cubeCoords[i+1][j][k+1];
				tmpCube.back[0]=cubeCoords[i][j][k];    tmpCube.back[1]=cubeCoords[i][j+1][k];    tmpCube.back[2]=cubeCoords[i+1][j+1][k];    tmpCube.back[3]=cubeCoords[i+1][j][k];

				cubeGrid[i][j][k] = tmpCube;
				/*cubeColor[i][j][k].r = 0.67;
				cubeColor[i][j][k].g = 0.26;
				cubeColor[i][j][k].b = 0.15;*/
			}
		}
	}
}//UpdateGeometry

//######################### TEST FUNCTIONS / OLD VERSIONS ###################################

void Mesh::DrawCoordSys()
{
	//Draw the coordinate system
	glBegin(GL_LINES);
	glColor3f(1.0, 0.0, 0.0);
	glVertex3f(-2.0, 0.0, 0.0);
	glVertex3f( 2.0, 0.0, 0.0);

	glColor3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, -2.0, 0.0);
	glVertex3f(0.0,  2.0, 0.0);
	
	glColor3f(0.0,0.0,1.0);
	glVertex3f(0.0, 0.0, -2.0);
	glVertex3f(0.0, 0.0,  2.0);
	glEnd();
}

void Mesh::CubeTest()
{
	// To awoid the affect of a spinning cube...
	glPushMatrix();

	//roter 0.1 grad rundt y-aksen (minus = cw)
	glRotatef(-20.0, 0.0, 1.0, 0.0);
	//roter 0.05 grad rundt x-aksen
	glRotatef(-30.0, 1.0, 0.0, 0.0);

	glBegin(GL_QUADS);
	//front quad
	/*glColor3f(1.0, 0.0, 0.0);
	glVertex3f(-1.0, -1.0, 1.0);
	glVertex3f( 1.0, -1.0, 1.0);
	glVertex3f( 1.0,  1.0, 1.0);
	glVertex3f(-1.0,  1.0, 1.0);*/
    
	//right quad
	glColor3f(0.0, 0.0, 1.0);
	glVertex3f( 1.0, -1.0, 1.0);
    glVertex3f( 1.0, -1.0, -1.0);
    glVertex3f( 1.0,  1.0, -1.0);
	glVertex3f( 1.0,  1.0, 1.0);
	
	//back quad
	glColor3f(0.0, 1.0, 0.0);
	glVertex3f(-1.0, -1.0, -1.0);
    glVertex3f(-1.0,  1.0, -1.0);
	glVertex3f( 1.0,  1.0, -1.0);
	glVertex3f( 1.0, -1.0, -1.0);

	//left quad
	glColor3f(1.0, 1.0, 0.0);
	glVertex3f( -1.0, -1.0, 1.0);
    glVertex3f( -1.0, -1.0, -1.0);
    glVertex3f( -1.0,  1.0, -1.0);
	glVertex3f( -1.0,  1.0, 1.0);

	//top quad
	glColor3f(0.0, 1.0, 1.0);
	glVertex3f(-1.0,  1.0, 1.0);
    glVertex3f( 1.0,  1.0, 1.0);
    glVertex3f( 1.0,  1.0, -1.0);
    glVertex3f(-1.0,  1.0, -1.0);

	//bottom quad
	glColor3f(1.0, 0.0, 1.0);
	glVertex3f(-1.0,  -1.0, 1.0);
	glVertex3f(-1.0,  -1.0, -1.0);
	glVertex3f( 1.0,  -1.0, -1.0);
    glVertex3f( 1.0,  -1.0, 1.0);

	glEnd();
	glPopMatrix();
}

void Mesh::TestLines()
{
	/*glBegin(GL_LINES);
	glColor3f(1.0, 0.0, 0.0);

	glVertex3f(0.0, 1.0, -1.6);
	glVertex3f(2.2, 1.0, -1.6);

	glVertex3f(0.0, 1.0, -1.5);
	glVertex3f(2.2, 1.0, -1.5);

	glVertex3f(0.0, -0.5, 2.0);
	glVertex3f(0.8, -0.5, 2.0);

	glVertex3f(0.0, -0.5, 2.1);
	glVertex3f(0.8, -0.5, 2.1);

	glEnd();*/

	glBegin(GL_QUADS);

	glVertex3f(-1, -1, 0);
	glVertex3f( 1,  1, 0);
	glVertex3f(-1,  1, 0);
	glVertex3f( 1, -1, 0);

	glEnd();
}

void OldGenMesh(int dimCubes)
{
	int n = dimCubes;
	float r = 1.0;
	float g = 1.0;
	float b = 1.0;

	float x = 0.0;
	float y = 0.0;
	float z = 0.0;
	//printf("x,y,z = %i, %i, %i", x, y, z);

	// To awoid the affect of a spinning cube...
	glPushMatrix();

	//roter 0.1 grad rundt y-aksen (minus = cw)
	glRotatef(-200.0, 0.0, 1.0, 0.0);
	//roter 0.05 grad rundt x-aksen
	//glRotatef(-30.0, 1.0, 0.0, 0.0);
	
	glBegin(GL_QUADS);
	//glColor3f(1, 0, 0);
	for (x=-(n/2-1); x<(n/2+1); x++){// 8=-3,4
		r -= 1.0/((float)(n+1));
		for (y=-(n/2-1); y<(n/2+1); y++){
			g -= 1.0/((float)(n+1));
			for (z=-(n/2-1); z<(n/2+1); z++){
				b -= 1.0/((float)(n+1));
				glColor3f(r, g, b);

				glVertex3f(x-1.0, y-1.0, z);
				glVertex3f(x-1.0, y,     z);
				glVertex3f(x,     y,     z);
				glVertex3f(x,     y-1.0, z);

				glVertex3f(x-1.0, y-1.0, z-1.0);
				glVertex3f(x    , y-1.0, z-1.0);
				glVertex3f(x,     y,     z-1.0);
				glVertex3f(x-1.0, y,     z-1.0);

                glVertex3f(x-1.0, y-1.0, z);
				glVertex3f(x-1.0, y,     z);
				glVertex3f(x-1.0, y,     z-1.0);
				glVertex3f(x-1.0, y-1.0, z-1.0);

				glVertex3f(x, y-1.0, z);
				glVertex3f(x, y,     z);
				glVertex3f(x, y,     z-1.0);
				glVertex3f(x, y-1.0, z-1.0);

				glVertex3f(x,     y, z);
				glVertex3f(x-1.0, y, z);
				glVertex3f(x-1.0, y, z-1.0);
				glVertex3f(x,     y, z-1.0);

				glVertex3f(x,     y-1.0, z);
				glVertex3f(x,     y-1.0, z-1.0);
				glVertex3f(x-1.0, y-1.0, z-1.0);
				glVertex3f(x-1.0, y-1.0, z);
			}
		}
	}

	glEnd();
	
	//Draw the coordinate system
	glBegin(GL_LINES);
	glColor3f(1.0, 0.0, 0.0);
	glVertex3f(-2.0, 0.0, 0.0);
	glVertex3f( 2.0, 0.0, 0.0);

	glColor3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, -2.0, 0.0);
	glVertex3f(0.0,  2.0, 0.0);
	
	glColor3f(0.0,0.0,1.0);
	glVertex3f(0.0, 0.0, -2.0);
	glVertex3f(0.0, 0.0,  2.0);
	glEnd();

	glPopMatrix();

	/*r=x; g=y; b=z;
	if(r==0.0 && g==0.0 && b==0.0) r=g=b=0.5;*/

	/*if (r==1.0) r=0.7;
	else r=0.3;
	glColor3f(r, g, b);*/
}

//######################### SCETCH ###################################

	/*if(firstRP){
		for (int i=0; i<2; i++){
			for (int j=0; j<2; j++){
				for (int k=0; k<2; k++){
					printf("x,y,z-pos i DrawCube: , %i %i %i: %.3f %.3f %.3f\n", i*2, j*2, k*2,
													leaf->cv->v[i*2][j*2][k*2]->origPos.x,
													leaf->cv->v[i*2][j*2][k*2]->origPos.y,
													leaf->cv->v[i*2][j*2][k*2]->origPos.z);
				}
			}
		}
		printf("\n\n");
	}*/

	//if (x > cubeGrid[i][j][k].left[0].x-bias){
	//	if (x < cubeGrid[i][j][k].left[0].x+bias){
	//		if (x < cubeGrid[i][j][k].left[0].x) xHit = i-1; 
	//		else if (x < cubeGrid[i+1][j][k].left[0]) xHit = i;//break; //Have found correct x-pos
	//		else xHit = i+1;
	//	}
	//}

	/*if (i==xItStart+1 && j==yItStart+1 && k==zItStart+1 ){
		std::cout << cubeCoords[i][j][k].x << " " << cubeCoords[i][j][k].y << " " <<  cubeCoords[i][j][k].z << "\n";
		std::cout << testDist << "\n";
	}
	printf("%f",sqrt( exp(x-cubeCoords[i][j][k].x)+exp(y-cubeCoords[i][j][k].y)+exp(z-cubeCoords[i][j][k].z) ));*/

	////Draw the coordinate system
	//glBegin(GL_LINES);
	//glColor3f(1.0, 0.0, 0.0);
	//glVertex3f(-2.0, 0.0, 0.0);
	//glVertex3f( 2.0, 0.0, 0.0);

	//glColor3f(0.0, 1.0, 0.0);
	//glVertex3f(0.0, -2.0, 0.0);
	//glVertex3f(0.0,  2.0, 0.0);
	//
	//glColor3f(0.0,0.0,1.0);
	//glVertex3f(0.0, 0.0, -2.0);
	//glVertex3f(0.0, 0.0,  2.0);
	//glEnd();

	//minDist = abs(proxyPos[0]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].left[0].x);
	//*hitFace=0;
	//if ( minDist > abs(proxyPos[0]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].right[0].x) )
	//	*hitFace=1;//right side
	//else if ( minDist > abs(proxyPos[1]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].bottom[0].y) )
	//	*hitFace=2;
	//else if ( minDist > abs(proxyPos[1]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].top[0].y) )
	//	*hitFace=3;
	//else if ( minDist > abs(proxyPos[2]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].back[0].z) )
	//	*hitFace=4;
	//else if ( minDist > abs(proxyPos[2]-cubeGrid[hitCube[0]][hitCube[1]][hitCube[2]].front[0].z) )
	//	*hitFace=5;

	//std::cout << "cube "<< hitCube[0] << hitCube[1] << hitCube[2] << " hit\n";

//###########################################################################################
