#include <stdio.h>
#include <stdlib.h>
#include "Mesh.h"

//spring stiffness
//#define k_x 8.0;


void Mesh::Simulate()
{
	//float alfa = 0.1;	//
	//float k_x = 80;	//spring stiffnes

	int n = verteksList.size();
	int n_iter = 4;

	for (int i=0; i<n_iter; i++){
        for (int k=0; k<n; k++){
			verteksList[k]->Move();
		}
	}
	//
	for (int k=0; k<n; k++){
		verteksList[k]->ClearExtForce();
	}
}

void Mesh::Old_Simulate(hduVector3Dd reactionForce, hduVector3Dd proxyPos)
{
	int hitCube[3];
	int hitFace;
	float k_x = 8.0;

	GetTouchedFace(proxyPos, hitCube, &hitFace);

	//std::cout << "SIMULATE: face, cube " << hitFace << "  " << hitCube[0] << " " << hitCube[1] << " " << hitCube[2] <<"\n";
	cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].x = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]].x - reactionForce[0]/k_x;
	cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].y = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]].y - reactionForce[1]/k_x;
	cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].z = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]].z - reactionForce[2]/k_x;
	
	//std::cout << "SIMULATE: vertice x-y-z coord BEFORE: " << cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].x << " " << cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].y << " "<< cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].z <<"\n";
	cubeCoords[ hitCube[0] ][ hitCube[1]+1 ][ hitCube[2] ].x = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]].x - reactionForce[0]/k_x;
	cubeCoords[ hitCube[0] ][ hitCube[1]+1 ][ hitCube[2] ].y = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]].y - reactionForce[1]/k_x;
	cubeCoords[ hitCube[0] ][ hitCube[1]+1 ][ hitCube[2] ].z = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]].z - reactionForce[2]/k_x;
	//std::cout << "SIMULATE: vertice x-y-z coord AFTER: " << cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].x << " " << cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].y << " "<< cubeCoords[ hitCube[0]][hitCube[1]][hitCube[2] ].z <<"\n\n";

	cubeCoords[hitCube[0]][hitCube[1]+1][hitCube[2]+1].x = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]+1].x - reactionForce[0]/k_x;
	cubeCoords[hitCube[0]][hitCube[1]+1][hitCube[2]+1].y = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]+1].y - reactionForce[1]/k_x;
	cubeCoords[hitCube[0]][hitCube[1]+1][hitCube[2]+1].z = orgCubeC[hitCube[0]][hitCube[1]+1][hitCube[2]+1].z - reactionForce[2]/k_x;

	cubeCoords[hitCube[0]][hitCube[1]][hitCube[2]+1].x = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]+1].x - reactionForce[0]/k_x;
	cubeCoords[hitCube[0]][hitCube[1]][hitCube[2]+1].y = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]+1].y - reactionForce[1]/k_x;
	cubeCoords[hitCube[0]][hitCube[1]][hitCube[2]+1].z = orgCubeC[hitCube[0]][hitCube[1]][hitCube[2]+1].z - reactionForce[2]/k_x;

	UpdateGeometry();

	//Possible improvement...				   i								  j									 k
	//cubeCoords[ cubeGrid[..][..][..].left[0][0] ][ cubeGrid[..][..][..].left[0][1] ][ cubeGrid[..][..][..].left[0][2] ].x

}//Mesh::Old_Simulate()